#version 150 core

uniform vec3 lightColor;
uniform sampler2D colorMap;

in vec4 pass_LightSpacePosition;
in vec3 pass_Normal;
in vec2 pass_TextCoord;

out vec4 out_Color;
out vec4 out_Normal;
out vec4 out_Light;

void main(void) {
	out_Color = texture2D(colorMap, pass_TextCoord);
	out_Normal = vec4( 0.5f * (pass_Normal + 1.0f) , 1.0);
	//out_Normal = vec4(pass_Normal, 1.0);
	
	float d = length(pass_LightSpacePosition.xyz)/256; //why division by 256? (otherwise much too dark)
	d = 1.0/(1.0 + pow(d, 2.0)); //1.1
	out_Light = vec4(d*lightColor.xyz, 1.0);
}