#version 150 core

uniform mat4 viewMatrix;
uniform mat4 projMatrix;
uniform mat4 modelMatrix;

in vec3 in_Position;
in vec3 in_Color;
in vec3 in_Normal;
in vec2 in_TextCoord;

out vec4 pass_LightSpacePosition;
out vec3 pass_Normal;
out vec2 pass_TextCoord;

void main(void) {
	// position, normal, textcoord
	gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(in_Position, 1.0);
	pass_Normal = normalize( (modelMatrix * vec4(in_Normal, 0.0)).xyz );
	pass_TextCoord = in_TextCoord;
	
	// light specific parameters
	pass_LightSpacePosition = viewMatrix * modelMatrix * vec4(in_Position, 1.0);

}