#version 150 core

//http://www.opengl-tutorial.org/intermediate-tutorials/tutorial-16-shadow-mapping/
//http://msdn.microsoft.com/en-us/library/windows/desktop/ee416324%28v=vs.85%29.aspx

const int NUMLIGHTS = 5;

uniform vec2 gridDimension;
	
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
uniform mat4 modelMatrix;

uniform mat4 invViewMatrix;
uniform mat4 invProjMatrix;

uniform mat4 lightView[NUMLIGHTS];
uniform mat4 lightProj;

in vec3 in_Position;
in vec2 in_TextCoord;
 
out vec2 pass_TextCoord;
out vec2 pass_TextCoordAtlas;
//out vec4 shadowCoord[NUMLIGHTS];

out mat4 lightMatrix[NUMLIGHTS];

void main(void) {
	gl_Position = vec4(in_Position, 1.0);
	
	// IF ATLAS
	pass_TextCoordAtlas = vec2(in_TextCoord.x/gridDimension.x, in_TextCoord.y/gridDimension.y);
	pass_TextCoordAtlas.x += 1.0/gridDimension.x;
	// ELSE
	pass_TextCoord = in_TextCoord;//vec2(in_TextCoord.x/gridDimension.x, in_TextCoord.y/gridDimension.y);
	
	for (int i=0; i<NUMLIGHTS; i++) {
	
		float scale = 0.5/float(NUMLIGHTS);
		//mat4 biasMatrix = mat4(   
		//	scale, 0.0, 0.0, 0.0,
		//	0.0,  0.5, 0.0, 0.0,
		//	0.0,  0.0, 0.5, 0.0,
		//	scale+2.0*float(i)*scale, 0.5, 0.5, 1.0);
		
		// between 0 and 1 (not -1 and 1)
		mat4 biasMatrix = mat4(   
			0.5, 0.0, 0.0, 0.0,
			0.0, 0.5, 0.0, 0.0,
			0.0, 0.0, 0.5, 0.0,
			0.5, 0.5, 0.5, 1.0);
	
		lightMatrix[i] = lightProj * lightView[i];
	
		//shadowCoord[i] = biasMatrix * lightProj * lightView[i] * modelMatrix * vec4(in_Position, 1.0);
		//shadowCoord[1] = BIASMATRIX1 * lightProj * lightView[1] * modelMatrix * vec4(in_Position, 1.0);
	}
	
}