#version 150 core

const int NUMLIGHTS = 5;

uniform sampler2D shadowAtlas;

//in vec4 pass_Color;
in vec4 shadowCoord[NUMLIGHTS];

out vec4 out_Color;

void main(void) {

	float factor = 1.0/float(NUMLIGHTS);
	out_Color = vec4(0.1, 0.1, 0.1, 1.0);
	
	float bias = 0.0001;
	
	float index = 0.0;
	for (int i=0; i<NUMLIGHTS; i++) {
	
		vec3 sCoord = shadowCoord[i].xyz/shadowCoord[i].w;
	
		if ( texture(shadowAtlas, sCoord.xy).z > (sCoord.z+bias)){
			out_Color += vec4(0.5*factor, 0.5*factor, 0.5*factor, 1.0);//pass_Color;
		}
		
	}
	
}