#version 150 core

//http://www.opengl-tutorial.org/intermediate-tutorials/tutorial-16-shadow-mapping/
//http://msdn.microsoft.com/en-us/library/windows/desktop/ee416324%28v=vs.85%29.aspx

const int NUMLIGHTS = 5;

uniform vec2 gridDimension;

// between -1 and 1 -> 0 to 0.5
/*const mat4 BIASMATRIX0 = mat4(   
	0.25, 0.0, 0.0, 0.0,
	0.0,  0.5, 0.0, 0.0,
	0.0,  0.0, 0.5, 0.0,
	0.25, 0.5, 0.5, 1.0);
const mat4 BIASMATRIX1 = mat4(   
	0.25, 0.0, 0.0, 0.0,
	0.0,  0.5, 0.0, 0.0,
	0.0,  0.0, 0.5, 0.0,
	0.75, 0.5, 0.5, 1.0);*/
	
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
uniform mat4 modelMatrix;

uniform mat4 lightView[NUMLIGHTS];
uniform mat4 lightProj;

in vec3 in_Position;
in vec3 in_Color;
 
//out vec4 pass_Color;
out vec4 shadowCoord[NUMLIGHTS];

void main(void) {
	gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(in_Position, 1.0);
	//pass_Color = vec4(in_Color, 1.0);
	
	for (int i=0; i<NUMLIGHTS; i++) {
	
		float scale = 0.5/float(NUMLIGHTS);
		mat4 biasMatrix = mat4(   
			scale, 0.0, 0.0, 0.0,
			0.0,  0.5, 0.0, 0.0,
			0.0,  0.0, 0.5, 0.0,
			scale+2.0*float(i)*scale, 0.5, 0.5, 1.0);
	
		shadowCoord[i] = biasMatrix * lightProj * lightView[i] * modelMatrix * vec4(in_Position, 1.0);
		//shadowCoord[1] = BIASMATRIX1 * lightProj * lightView[1] * modelMatrix * vec4(in_Position, 1.0);
	}
	
}