package modules;

import modules.commands.CommandExecutor;
import modules.commands.Command_Factory;
import modules.loader.LoaderModule;
import modules.loader.Scene;
import modules.render.RenderModule;


public class RuntimeManager {

	private Module[] modules;
	
	public RuntimeManager() {
		modules = new Module[2];
		
		CommandExecutor commandExecutor = new CommandExecutor();
		Command_Factory commandFactory = new Command_Factory(modules);
		
		// scene is shared between modules
		Scene scene = new Scene();
		
		modules[0] = new RenderModule(scene, commandExecutor, commandFactory, 0);
		modules[1] = new LoaderModule(scene, commandExecutor, commandFactory, 1000);
		
		
		// start modules
		for (Module module : modules) {
			new Thread(module).start();
		}
		
	}
	
	public void shutdown() {
		for (int i = 0; i < modules.length; i++) {
			modules[i].shutdown();
		}
	}
	
	
}
