package modules.commands;

import modules.Module;

/**
 * Command pattern command to shut down all modules.
 * @author DarkMatt
 *
 */
public class CShutdownAllModules implements ICommand {

	private Module[] m;
	
	public CShutdownAllModules(Module[] modules) {
		m = modules;
	}
	
	@Override
	public void execute() {
		for (Module module : m) {
			module.shutdown();
		}
	}
	
}
