package modules.render;
//package modules.render;
//
//import java.util.ArrayList;
//import java.util.HashMap;
//
//
//import module.render.CameraParameters;
//import module.render.Material.ShadingMode;
//
//import org.lwjgl.opengl.GL11;
//
//
///**
// * Top level container and definition for shader.
// * 
// * Implements functionality of multiple Shaders and Variables to Shaders.
// * 
// * @author DarkMatt
// *
// */
//
//public class ShaderCollection {
//
//	/*
//	 * Merely to integrate the available shader into the engine.
//	 * 
//	 * Possibility to automate this process later on.
//	 */
//	
//	//shader
//	public static final int BASIC = 0;
//	public static final int PARTICLE = 1;
//	public static final int SKYBOX = 2;
//	public static final int POSTBLUR = 3;
//	public static final int GLOW = 4;
//	public static final int TERRAIN = 5;
//	public static final int NOTEXTURE = 6;
//	public static final int GHOST = 7;
//	public static final int TESS = 8;
//	public static final int MARKING = 9;
//	public static final int GODRAY = 10;
//	public static final int TEXTURED = 11;
//	public static final int DEFERREDG = 12;
//	public static final int DEFERREDPOINTLIGHT = 13;
//	public static final int DEFERREDDIRECTIONAL = 14;
//	public static final int NULL = 15;
//	public static final int SFQDEBUG = 16;
//	public static final int DEFERREDDIRECTIONALSM = 17;
//	public static final int SSVSMDEPTH = 18;
//	public static final int DEPTH_BLUR = 19;
//	public static final int DEFERRED_BLUR = 20;
//	public static final int DEFERRED_WATER = 21;
//	
//	private ShaderWrapper activeShader = null;
//	
//	/**
//	 * Wraps the Shader to allow arbitrary parameters.
//	 * Parameters are lazy initialized.
//	 * 
//	 * @author DarkMatt
//	 *
//	 */
//	private class ShaderWrapper extends Shader {
//		
//		/** Shader uniform locations */
//		private HashMap<String, Integer> shaderUniforms;
//		
//		public ShaderWrapper(String path) {
//			super(path);
//		}
//		
//		/**
//		 * "Lazy initialization".
//		 * 
//		 * Requires String/value pairs
//		 * 
//		 * @param params
//		 */
//		public void setShaderParameters(Object ... params) {
//			
//			// Error handling
//			if (params.length%2 != 0) throw new RuntimeException("ShaderCollection: Invalid number of Shader parameters.");
//			
//			// Initialize if necessary
//			if (shaderUniforms == null) {
//				shaderUniforms = new HashMap<String, Integer>();
//				
//				for (int i = 0; i < params.length; i+=2) {
//					String uniformName = String.valueOf(params[i]);
//					Integer location = this.initUniform(uniformName);
//					
//					if (location == -1) {
//						System.out.println("ShaderCollection: Uniform " + uniformName + " not found in Shader file." );
//					}
//					
//					shaderUniforms.put(uniformName, location);
//				}
//			}
//			
//			// Sets the Uniforms
//			for (int i = 0; i < params.length; i+=2) {
//				
//				Integer location = shaderUniforms.get(params[i]);
//				
//				if (location != null) {
//				
//					if (params[i+1] instanceof Integer) {
//						//System.out.println("Integer " + params[i+1]);
//						this.setValue1i(location, (Integer)params[i+1]);
//						
//					} else if (params[i+1] instanceof Float) {
//						//System.out.println("Float " + params[i+1]);
//						this.setValue1f(location, (Float)params[i+1]);
//						
//					} else if (params[i+1] instanceof int[]) {
//						int[] arr = (int[])params[i+1];
//						if (arr.length == 2) {
//							this.setValueVec2f(location, (float)arr[0], (float)arr[1]);
//						}
//						
//					} else if (params[i+1] instanceof float[]) {
//						float[] arr = (float[])params[i+1];
//						if (arr.length == 2) {
//							this.setValueVec2f(location, arr[0], arr[1]);
//						} else if (arr.length == 3) {
//							this.setValueVec3f(location, arr[0], arr[1], arr[2]);
//						} else if (arr.length == 16) {
//							this.setValueMat4f(location, arr);
//						}
//						
//					} else {
//						System.out.println("ShaderCollection: Type " + params[i+1].getClass().getName() + " not recognized.");
//					}
//					
//				} else {
//					
//					System.out.println("ShaderColelction: Variable " + params[i] + " does not exsist in shader " + this.getName());
//					
//				}
//				
//			}
//			
//		}
//		
//	}
//	
//	private ArrayList<ShaderWrapper> shader;
//	private int basic_modelMatrix, basic_viewMatrix, basic_projMatrix, basic_color, basic_colorMap;
//	private int basic_in_Position, basic_in_Normal, basic_in_TextCoord;
//	//private int particle_modelMatrix, particle_viewMatrix, particle_projMatrix, particle_timer, particle_color, particle_colorMap, particle_depthMap;
//	private int particle_in_Position;
//	//private int skybox_viewMatrix, skybox_projMatrix, skybox_color;
//	private int skybox_in_Position;
//	private int post_blur_colorMap, post_blur_glowMap, post_blur_resolutionOffset;
//	private int post_blur_in_Position, post_blur_in_TextCoord;
//	private int glow_modelMatrix, glow_viewMatrix, glow_projMatrix, glow_color, glow_colorMap, glow_glowMap, glow_animator, glow_specular, glow_lightIntensity;
//	private int glow_in_Position, glow_in_Normal, glow_in_Color, glow_in_TextCoord;
//	private int terrain_modelMatrix, terrain_viewMatrix, terrain_projMatrix, terrain_color, terrain_colorMap, terrain_normalMap;
//	private int terrain_in_Position, terrain_in_Normal, terrain_in_Color, terrain_in_TextCoord;
//	private int notexture_modelMatrix, notexture_viewMatrix, notexture_projMatrix;
//	private int notexture_in_Position, notexture_in_Color;
//	private int ghost_modelMatrix, ghost_viewMatrix, ghost_projMatrix, ghost_color, ghost_colorMap, ghost_glowMap, ghost_animator;
//	private int ghost_in_Position, ghost_in_Normal, ghost_in_Color, ghost_in_TextCoord;
//	private int tess_modelMatrix, tess_viewMatrix, tess_projMatrix, tess_camPos, tess_colorMap, tess_displacementMap, tess_timer;
//	private int tess_in_Position, tess_in_Normal, tess_in_TextCoord;
//	private int marking_modelMatrix, marking_viewMatrix, marking_projMatrix, marking_timer, marking_colorMap, marking_depthMap;
//	private int marking_in_Position, marking_in_TextCoord;
//	private int godray_viewMatrix, godray_projMatrix, godray_colorMap, godray_depthMap;
//	private int godray_in_Position, godray_in_TextCoord;
//	private int textured_modelMatrix, textured_viewMatrix, textured_projMatrix, textured_colorMap;
//	private int textured_in_Position, textured_in_TextCoord, textured_in_ModelMatrices;
//	private int deferredG_in_Position, deferredG_in_Normal, deferredG_in_TextCoord, deferredG_in_Tangents, deferredG_in_ModelMatrices;
//	private int deferredDirectional_in_Position, deferredDirectional_in_TextCoord;
//	private int deferredLight_in_Position;
//	private int null_modelMatrix, null_viewMatrix, null_projMatrix, null_in_ModelMatrices;
//	private int null_in_Position;
//	private int sfqdebug_in_Position, sfqdebug_in_TextCoord;
//	private int deferredDirectionalSM_in_Position, deferredDirectionalSM_in_TextCoord;
//	private int ssVsmDepth_in_Position, ssVsmDepth_in_TextCoord;
//	private int depth_blur_in_Position, depth_blur_in_TextCoord;
//	private int deferred_blur_in_Position, deferred_blur_in_TextCoord;
//	private int deferred_water_in_Position, deferred_water_in_TextCoord;
//	
//	public ShaderCollection() {
//		shader = new ArrayList<ShaderWrapper>();
//		
//		shader.add(new ShaderWrapper("/shader/default"));
//		basic_modelMatrix = shader.get(BASIC).initUniform("modelMatrix");
//		basic_viewMatrix = shader.get(BASIC).initUniform("viewMatrix");
//		basic_projMatrix = shader.get(BASIC).initUniform("projMatrix");
//		basic_color = shader.get(BASIC).initUniform("color");
//    	basic_colorMap = shader.get(BASIC).initUniform("colorMap");
//    	basic_in_Position = shader.get(BASIC).initInOut("in_Position");
//    	basic_in_Normal = shader.get(BASIC).initInOut("in_Normal");
//    	basic_in_TextCoord = shader.get(BASIC).initInOut("in_TextCoord");
//    	
//		shader.add(new ShaderWrapper("/shader/particle"));
//		/*particle_modelMatrix = shader.get(PARTICLE).initUniform("modelMatrix");
//		particle_viewMatrix = shader.get(PARTICLE).initUniform("viewMatrix");
//		particle_projMatrix = shader.get(PARTICLE).initUniform("projMatrix");
//		particle_timer = shader.get(PARTICLE).initUniform("timer");
//		particle_color = shader.get(PARTICLE).initUniform("fogColor");
//		particle_colorMap = shader.get(PARTICLE).initUniform("colorMap");
//		particle_depthMap = shader.get(PARTICLE).initUniform("depthMap");*/
//		particle_in_Position = shader.get(PARTICLE).initInOut("in_Position");
//		
//		shader.add(new ShaderWrapper("/shader/skybox"));
//		//skybox_viewMatrix = shader.get(SKYBOX).initUniform("viewMatrix");
//		//skybox_projMatrix = shader.get(SKYBOX).initUniform("projMatrix");
//		//skybox_color = shader.get(SKYBOX).initUniform("colorMod");
//		skybox_in_Position = shader.get(SKYBOX).initInOut("in_Position");
//		
//		shader.add(new ShaderWrapper("/shader/post_blur"));
//		post_blur_colorMap = shader.get(POSTBLUR).initUniform("colorMap");
//		post_blur_glowMap = shader.get(POSTBLUR).initUniform("glowMap");
//		post_blur_resolutionOffset = shader.get(POSTBLUR).initUniform("resolutionOffset");
//		post_blur_in_Position = shader.get(POSTBLUR).initInOut("in_Position");
//		post_blur_in_TextCoord = shader.get(POSTBLUR).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/glow"));
//		glow_modelMatrix = shader.get(GLOW).initUniform("modelMatrix");
//		glow_viewMatrix = shader.get(GLOW).initUniform("viewMatrix");
//		glow_projMatrix = shader.get(GLOW).initUniform("projMatrix");
//		glow_color = shader.get(GLOW).initUniform("color");
//		glow_colorMap = shader.get(GLOW).initUniform("colorMap");
//		glow_glowMap = shader.get(GLOW).initUniform("glowMap");
//		glow_animator = shader.get(GLOW).initUniform("animator");
//		glow_specular = shader.get(GLOW).initUniform("specularStr");
//		glow_lightIntensity = shader.get(GLOW).initUniform("lightIntensity");
//		glow_in_Position = shader.get(GLOW).initInOut("in_Position");
//		glow_in_Normal = shader.get(GLOW).initInOut("in_Normal");
//		glow_in_Color = shader.get(GLOW).initInOut("in_Color");
//		glow_in_TextCoord = shader.get(GLOW).initInOut("in_TextCoord");
//		
//		//TERRAIN
//		shader.add(new ShaderWrapper("/shader/terrain"));
//		terrain_modelMatrix = shader.get(TERRAIN).initUniform("modelMatrix");
//		terrain_viewMatrix = shader.get(TERRAIN).initUniform("viewMatrix");
//		terrain_projMatrix = shader.get(TERRAIN).initUniform("projMatrix");
//		terrain_color = shader.get(TERRAIN).initUniform("color");
//		terrain_colorMap = shader.get(TERRAIN).initUniform("colorMap");
//		terrain_normalMap = shader.get(TERRAIN).initUniform("normalMap");
//		terrain_in_Position = shader.get(TERRAIN).initInOut("in_Position");
//		terrain_in_Normal = shader.get(TERRAIN).initInOut("in_Normal");
//		terrain_in_Color = shader.get(TERRAIN).initInOut("in_Color");
//		terrain_in_TextCoord = shader.get(TERRAIN).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/notexture"));
//		notexture_modelMatrix = shader.get(NOTEXTURE).initUniform("modelMatrix");
//		notexture_viewMatrix = shader.get(NOTEXTURE).initUniform("viewMatrix");
//		notexture_projMatrix = shader.get(NOTEXTURE).initUniform("projMatrix");
//		notexture_in_Position = shader.get(NOTEXTURE).initInOut("in_Position");
//		notexture_in_Color = shader.get(NOTEXTURE).initInOut("in_Color");
//		
//		shader.add(new ShaderWrapper("/shader/ghost"));
//		ghost_modelMatrix = shader.get(GHOST).initUniform("modelMatrix");
//		ghost_viewMatrix = shader.get(GHOST).initUniform("viewMatrix");
//		ghost_projMatrix = shader.get(GHOST).initUniform("projMatrix");
//		ghost_color = shader.get(GHOST).initUniform("color");
//		ghost_colorMap = shader.get(GHOST).initUniform("colorMap");
//		ghost_glowMap = shader.get(GHOST).initUniform("glowMap");
//		ghost_animator = shader.get(GHOST).initUniform("animator");
//		ghost_in_Position = shader.get(GHOST).initInOut("in_Position");
//		ghost_in_Normal = shader.get(GHOST).initInOut("in_Normal");
//		ghost_in_Color = shader.get(GHOST).initInOut("in_Color");
//		ghost_in_TextCoord = shader.get(GHOST).initInOut("in_TextCoord");
//		
//		//shader.add(new Shader("/shader/ghost")); //TODO temp disable for gdebugger
//		shader.add(new ShaderWrapper("/shader/tess")); 
//		tess_modelMatrix = shader.get(TESS).initUniform("modelMatrix");
//		tess_viewMatrix = shader.get(TESS).initUniform("viewMatrix");
//		tess_projMatrix = shader.get(TESS).initUniform("projMatrix");
//		tess_camPos = shader.get(TESS).initUniform("camPos");
//		tess_colorMap = shader.get(TESS).initUniform("colorMap");
//		tess_displacementMap = shader.get(TESS).initUniform("displacementMap");
//		tess_timer = shader.get(TESS).initUniform("timer");
//		tess_in_Position = shader.get(TESS).initInOut("in_Position");
//		tess_in_Normal = shader.get(TESS).initInOut("in_Normal");
//		tess_in_TextCoord = shader.get(TESS).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/floor_marking"));
//		marking_modelMatrix = shader.get(MARKING).initUniform("modelMatrix");
//		marking_viewMatrix = shader.get(MARKING).initUniform("viewMatrix");
//		marking_projMatrix = shader.get(MARKING).initUniform("projMatrix");
//		marking_timer = shader.get(MARKING).initUniform("timer");
//		marking_colorMap = shader.get(MARKING).initUniform("colorMap");
//		marking_depthMap = shader.get(MARKING).initUniform("depthMap");
//		marking_in_Position = shader.get(MARKING).initInOut("in_Position");
//		marking_in_TextCoord = shader.get(MARKING).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/godray"));
//		godray_viewMatrix = shader.get(GODRAY).initUniform("viewMatrix");
//		godray_projMatrix = shader.get(GODRAY).initUniform("projMatrix");
//		godray_colorMap = shader.get(GODRAY).initUniform("colorMap");
//		godray_depthMap = shader.get(GODRAY).initUniform("glowMap");
//		godray_in_Position = shader.get(GODRAY).initInOut("in_Position");
//		godray_in_TextCoord = shader.get(GODRAY).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/textured"));
//		textured_modelMatrix = shader.get(TEXTURED).initUniform("modelMatrix");
//		textured_viewMatrix = shader.get(TEXTURED).initUniform("viewMatrix");
//		textured_projMatrix = shader.get(TEXTURED).initUniform("projMatrix");
//		textured_colorMap = shader.get(TEXTURED).initUniform("colorMap");
//		textured_in_Position = shader.get(TEXTURED).initInOut("in_Position");
//    	textured_in_TextCoord = shader.get(TEXTURED).initInOut("in_TextCoord");
//    	textured_in_ModelMatrices = shader.get(TEXTURED).initInOut("in_ModelMatrix");
//    	
//    	shader.add(new ShaderWrapper("/shader/deferredG"));
//		deferredG_in_Position = shader.get(DEFERREDG).initInOut("in_Position");
//		deferredG_in_Normal = shader.get(DEFERREDG).initInOut("in_Normal");
//		deferredG_in_TextCoord = shader.get(DEFERREDG).initInOut("in_TextCoord");
//		deferredG_in_Tangents = shader.get(DEFERREDG).initInOut("in_Tangents");
//		deferredG_in_ModelMatrices = shader.get(DEFERREDG).initInOut("in_ModelMatrix");
//		
//		shader.add(new ShaderWrapper("/shader/deferredPointLight"));
//		deferredLight_in_Position = shader.get(DEFERREDPOINTLIGHT).initInOut("in_Position");
//		
//		shader.add(new ShaderWrapper("/shader/deferredDirectional"));
//		deferredDirectional_in_Position = shader.get(DEFERREDDIRECTIONAL).initInOut("in_Position");
//		deferredDirectional_in_TextCoord = shader.get(DEFERREDDIRECTIONAL).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/null"));
//		null_modelMatrix = shader.get(NULL).initUniform("modelMatrix");
//		null_viewMatrix = shader.get(NULL).initUniform("viewMatrix");
//		null_projMatrix = shader.get(NULL).initUniform("projMatrix");
//		null_in_Position = shader.get(NULL).initInOut("in_Position");
//		null_in_ModelMatrices = shader.get(NULL).initInOut("in_ModelMatrix");
//		
//		shader.add(new ShaderWrapper("/shader/sfqDebug"));
//		sfqdebug_in_Position = shader.get(SFQDEBUG).initInOut("in_Position");
//		sfqdebug_in_Position = shader.get(SFQDEBUG).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/deferredDirectionalSM"));
//		deferredDirectionalSM_in_Position = shader.get(DEFERREDDIRECTIONALSM).initInOut("in_Position");
//		deferredDirectionalSM_in_TextCoord = shader.get(DEFERREDDIRECTIONALSM).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/ssVsmDepth"));
//		ssVsmDepth_in_Position = shader.get(SSVSMDEPTH).initInOut("in_Position");
//		ssVsmDepth_in_TextCoord = shader.get(SSVSMDEPTH).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/depth_blur"));
//		depth_blur_in_Position = shader.get(DEPTH_BLUR).initInOut("in_Position");
//		depth_blur_in_TextCoord = shader.get(DEPTH_BLUR).initInOut("in_TextCoord");
//	
//		shader.add(new ShaderWrapper("/shader/deferred_blur"));
//		deferred_blur_in_Position = shader.get(DEFERRED_BLUR).initInOut("in_Position");
//		deferred_blur_in_TextCoord = shader.get(DEFERRED_BLUR).initInOut("in_TextCoord");
//		
//		shader.add(new ShaderWrapper("/shader/deferredWater"));
//		deferred_water_in_Position = shader.get(DEFERRED_WATER).initInOut("in_Position");
//		deferred_water_in_TextCoord = shader.get(DEFERRED_WATER).initInOut("in_TextCoord");
//		
//	}
//	
//	/**
//	 * Using varargs.
//	 * 
//	 * Use: ("shaderName", value, ...)
//	 * 
//	 * @param params
//	 */
//	public void setShaderParameters(Object ... params) {
//		
//		activeShader.setShaderParameters(params);
//		
//	}
//	
//	/**
//	 * This is not an optimal solution. (Visitor pattern?)
//	 * 
//	 * setShaderParameter -> "accept"
//	 * 
//	 * Shader.setShaderParameters(...); -> "accept"
//	 * 
//	 * example:
//	 *  - BasicShader() extends Shader { int modelMatrix; }
//	 * 
//	 * 
//	 * @param type
//	 * @param modelMatrix
//	 * @param camera
//	 * @param param
//	 * @param timer
//	 * @param specular
//	 * @param lightIntensity
//	 */
//	@Deprecated
//	public void setShaderParameters(int type, float[] modelMatrix, CameraParameters camera, float[] param, float timer, float specular, float lightIntensity) {
//		
//		switch (type) {
//			case BASIC:
//				
//				shader.get(type).setValueMat4f(basic_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(basic_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(basic_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValueVec4f(basic_color, param[0], param[1], param[2], param[3]);
//		    	shader.get(type).setValue1i(basic_colorMap, 0); //Texture unit 0 is for base images.
//		    	
//				break;
//				
//			case POSTBLUR:
//				
//				shader.get(type).setValue1i(post_blur_colorMap, 0);
//				shader.get(type).setValue1i(post_blur_glowMap, 1); 
//				shader.get(type).setValueVec2f(post_blur_resolutionOffset, param[0], param[1]);
//				
//				break;
//				
//			case GLOW:
//				
//				shader.get(type).setValueMat4f(glow_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(glow_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(glow_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValueVec4f(glow_color, param[0], param[1], param[2], param[3]);
//				shader.get(type).setValue1f(glow_animator, timer);
//				shader.get(type).setValue1f(glow_specular, specular);
//				shader.get(type).setValue1f(glow_lightIntensity, lightIntensity);
//		    	shader.get(type).setValue1i(glow_colorMap, 0); //Texture unit 0 is for base images.
//		    	shader.get(type).setValue1i(glow_glowMap, 1);
//		    	
//				break;
//				
//			case TERRAIN:
//				
//				shader.get(type).setValueMat4f(terrain_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(terrain_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(terrain_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValueVec4f(terrain_color, param[0], param[1], param[2], param[3]);
//		    	shader.get(type).setValue1i(terrain_colorMap, 0); //Texture unit 0 is for base images.
//		    	shader.get(type).setValue1i(terrain_normalMap, 1);
//		    	
//				break;
//				
//			case NOTEXTURE:
//				
//				//C.ln(modelMatrix[3]);
//				
//				shader.get(type).setValueMat4f(notexture_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(notexture_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(notexture_projMatrix, camera.getProjMatrix());
//		    	
//				break;
//				
//			case GHOST:
//				
//				shader.get(type).setValueMat4f(ghost_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(ghost_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(ghost_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValueVec4f(ghost_color, param[0], param[1], param[2], param[3]);
//				shader.get(type).setValue1f(ghost_animator, timer);
//		    	shader.get(type).setValue1i(ghost_colorMap, 0); //Texture unit 0 is for base images.
//		    	shader.get(type).setValue1i(ghost_glowMap, 1);
//		    	
//				break;
//				
//			case TESS:
//				
//				shader.get(type).setValueMat4f(tess_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(tess_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(tess_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValueVec4f(tess_camPos, param[0], param[1], param[2], param[3]);
//				shader.get(type).setValue1f(tess_timer, timer);
//				shader.get(type).setValue1i(tess_colorMap, 0);
//				shader.get(type).setValue1i(tess_displacementMap, 1);
//				
//				break;
//				
//			case MARKING:
//				
//				shader.get(type).setValueMat4f(marking_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(marking_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(marking_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValue1f(marking_timer, timer);
//				shader.get(type).setValue1i(marking_colorMap, 0);
//				shader.get(type).setValue1i(marking_depthMap, 1);
//								
//				break;
//				
//			case GODRAY:
//				
//				shader.get(type).setValueMat4f(godray_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(godray_projMatrix, camera.getProjMatrix());
//				shader.get(type).setValue1i(godray_colorMap, 0);
//				shader.get(type).setValue1i(godray_depthMap, 1);
//								
//				break;
//				
//			case TEXTURED:
//				
//				shader.get(type).setValueMat4f(textured_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(textured_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(textured_projMatrix, camera.getProjMatrix());
//		    	shader.get(type).setValue1i(textured_colorMap, 0); //Texture unit 0 is for base images.
//		    	
//				break;
//				
//			case NULL:
//				
//				shader.get(type).setValueMat4f(null_modelMatrix, modelMatrix);
//				shader.get(type).setValueMat4f(null_viewMatrix, camera.getViewMatrix());
//				shader.get(type).setValueMat4f(null_projMatrix, camera.getProjMatrix());
//		    	
//				break;
//				
//			default:
//				break;
//		}
//	}
//	
//	public int getVertexLocation(int type) {
//		switch (type) {
//			case BASIC:
//				//the index is not the index inside the shader!
//				return shader.get(type).getInOut(basic_in_Position);
//			case PARTICLE:
//				return shader.get(type).getInOut(particle_in_Position);
//			case SKYBOX:
//				return shader.get(type).getInOut(skybox_in_Position);
//			case POSTBLUR:
//				return shader.get(type).getInOut(post_blur_in_Position);
//			case GLOW:
//				return shader.get(type).getInOut(glow_in_Position);
//			case TERRAIN:
//				return shader.get(type).getInOut(terrain_in_Position);
//			case NOTEXTURE:
//				return shader.get(type).getInOut(notexture_in_Position);
//			case GHOST:
//				return shader.get(type).getInOut(ghost_in_Position);
//			case TESS:
//				return shader.get(type).getInOut(tess_in_Position);
//			case MARKING:
//				return shader.get(type).getInOut(marking_in_Position);
//			case GODRAY:
//				return shader.get(type).getInOut(godray_in_Position);
//			case TEXTURED:
//				return shader.get(type).getInOut(textured_in_Position);
//			case DEFERREDG:
//				return shader.get(type).getInOut(deferredG_in_Position);
//			case DEFERREDPOINTLIGHT:
//				return shader.get(type).getInOut(deferredLight_in_Position);
//			case DEFERREDDIRECTIONAL:
//				return shader.get(type).getInOut(deferredDirectional_in_Position);
//			case NULL:
//				return shader.get(type).getInOut(null_in_Position);
//			case SFQDEBUG:
//				return shader.get(type).getInOut(sfqdebug_in_Position);
//			case DEFERREDDIRECTIONALSM:
//				return shader.get(type).getInOut(deferredDirectionalSM_in_Position);
//			case SSVSMDEPTH:
//				return shader.get(type).getInOut(ssVsmDepth_in_Position);
//			case DEPTH_BLUR:
//				return shader.get(type).getInOut(depth_blur_in_Position);
//			case DEFERRED_BLUR:
//				return shader.get(type).getInOut(deferred_blur_in_Position);
//			case DEFERRED_WATER:
//				return shader.get(type).getInOut(deferred_water_in_Position);
//			default:
//				return -1;
//		}
//	}
//	
//	public int getNormalLocation(int type) {
//		switch (type) {
//			case BASIC:
//				//the index is not the index inside the shader!
//				return shader.get(type).getInOut(basic_in_Normal);
//			case GLOW:
//				return shader.get(type).getInOut(glow_in_Normal);
//			case TERRAIN:
//				return shader.get(type).getInOut(terrain_in_Normal);
//			case GHOST:
//				return shader.get(type).getInOut(ghost_in_Normal);
//			case TESS:
//				return shader.get(type).getInOut(tess_in_Normal);
//			case DEFERREDG:
//				return shader.get(type).getInOut(deferredG_in_Normal);
//			default:
//				return -1;
//		}
//	}
//	
//	public int getTangentLocation(int type) {
//		
//		switch (type) {
//		case DEFERREDG:
//			return shader.get(type).getInOut(deferredG_in_Tangents);
//		default:
//			return -1;
//		}
//		
//	}
//	
//	public int getTextCoordLocation(int type) {
//		switch (type) {
//			case BASIC:
//				//the index is not the index inside the shader!
//				return shader.get(type).getInOut(basic_in_TextCoord);
//			case POSTBLUR:
//				return shader.get(type).getInOut(post_blur_in_TextCoord);
//			case GLOW:
//				return shader.get(type).getInOut(glow_in_TextCoord);
//			case TERRAIN:
//				return shader.get(type).getInOut(terrain_in_TextCoord);
//			case GHOST:
//				return shader.get(type).getInOut(ghost_in_TextCoord);
//			case TESS:
//				return shader.get(type).getInOut(tess_in_TextCoord);
//			case MARKING:
//				return shader.get(type).getInOut(marking_in_TextCoord);
//			case GODRAY:
//				return shader.get(type).getInOut(godray_in_TextCoord);
//			case TEXTURED:
//				return shader.get(type).getInOut(textured_in_TextCoord);
//			case DEFERREDG:
//				return shader.get(type).getInOut(deferredG_in_TextCoord);
//			case DEFERREDDIRECTIONAL:
//				return shader.get(type).getInOut(deferredDirectional_in_TextCoord);
//			case SFQDEBUG:
//				return shader.get(type).getInOut(sfqdebug_in_TextCoord);
//			case DEFERREDDIRECTIONALSM:
//				return shader.get(type).getInOut(deferredDirectionalSM_in_TextCoord);
//			case SSVSMDEPTH:
//				return shader.get(type).getInOut(ssVsmDepth_in_TextCoord);
//			case DEPTH_BLUR:
//				return shader.get(type).getInOut(depth_blur_in_TextCoord);
//			case DEFERRED_BLUR:
//				return shader.get(type).getInOut(deferred_blur_in_TextCoord);
//			case DEFERRED_WATER:
//				return shader.get(type).getInOut(deferred_water_in_TextCoord);
//			default:
//				return -1;
//		}
//	}
//	
//	public int getColorLocation(int type) {
//		switch (type) {
//			case GLOW:
//				return shader.get(type).getInOut(glow_in_Color);
//			case TERRAIN:
//				return shader.get(type).getInOut(terrain_in_Color);
//			case NOTEXTURE:
//				return shader.get(type).getInOut(notexture_in_Color);
//			case GHOST:
//				return shader.get(type).getInOut(ghost_in_Color);
//			default:
//				return -1;
//		}
//	}
//	
//	public int getmodelMatrixLocation(int type) {
//		switch (type) {
//			case TEXTURED:
//				return shader.get(type).getInOut(textured_in_ModelMatrices);
//			case DEFERREDG:
//				return shader.get(type).getInOut(deferredG_in_ModelMatrices);
//			case NULL:
//				return shader.get(type).getInOut(null_in_ModelMatrices);
//			default:
//				return -1;
//		}
//	}
//	
//	public void bind(int name, ShadingMode shading) {
//		if (shading == ShadingMode.WIREFRAME) {
//			GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_LINE);
//		} else {
//			GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
//		}
//		shader.get(name).bind();
//		activeShader = shader.get(name);
//	}
//	
//	public void unbind(int name) {
//		shader.get(name).unbind();
//	}
//	
//	public void unbindAll() {
//		for (int i=0; i<shader.size(); i++)
//			shader.get(i).unbind();
//	}
//	
//}
