//package modules.render;
//
//import java.nio.FloatBuffer;
//import java.nio.IntBuffer;
//
//import module.render.shader.ShaderCollection;
//
//import org.lwjgl.BufferUtils;
//import org.lwjgl.opengl.GL11;
//import org.lwjgl.opengl.GL15;
//import org.lwjgl.opengl.GL20;
//import org.lwjgl.opengl.GL32;
//import org.lwjgl.opengl.GL33;
//
//public class VBOInstanced extends VBO {
//
//	/** matrix buffer object */
//	private IntBuffer vboMatrixInstances;
//	
//	public VBOInstanced() {
//		super();
//		vboMatrixInstances = BufferUtils.createIntBuffer(SIZE);
//		
//		// provides buffers to be bound later on
//		GL15.glGenBuffers(vboMatrixInstances);
//	}
//	
//	/*
//	@Override
//	public void init(int objectId, FloatBuffer vertices, FloatBuffer colors, FloatBuffer textCoords, ShortBuffer indices, FloatBuffer normals, int numberOfInstances) {
//		
//		super.init(objectId, vertices, colors, textCoords, indices, normals, numberOfInstances);
//		
//		// instance matrix array
//		
//		//GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboMatrixInstances.get(objectId));
//		
//		//System.out.println(objectId + " has instances: " + numberOfInstances);
//		
//	}*/
//	
//	@Override
//	public void activateInstance(int objectId, int shaderType, ShaderCollection sc) {
//		super.activateInstance(objectId, shaderType, sc);
//		
//	}
//	
//	@Override
//	public void renderInstances(int objectId, int type, int indicesSize, int numInstances, float[] modelMatrices, int shaderType, ShaderCollection sc) {
//
//		//System.out.println(objectId + " / " + indicesSize);
//		
//		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboMatrixInstances.get(objectId));
//		
//		int ml = sc.getmodelMatrixLocation(shaderType);
//		
//		//System.out.println("Shader type " + shaderType + " with matrix location " + ml);
//		
//		for (int i = 0; i < 4; i++) {
//			GL20.glEnableVertexAttribArray(ml+i);
//			//glVertexAttribPointer - defines the data format at an active INDEX (as enabled beforehand), the last is a pointer offset in bytes
//			//4 bytes in a float: 16 entries in matrix, iterate over all 4-groups
//			GL20.glVertexAttribPointer(ml+i, 4, GL11.GL_FLOAT, false, 4*16, 4*i*4); //4*16, 4*i*4);
//	        GL33.glVertexAttribDivisor(ml+i, 1);
//		}
//		
//		FloatBuffer m = BufferUtils.createFloatBuffer(modelMatrices.length);
//		m.put(modelMatrices, 0, 16*numInstances);
//		m.position(0);
//		GL15.glBufferData(GL15.GL_ARRAY_BUFFER, m, GL15.GL_STREAM_DRAW); //GL_STREAM_DRAW
//		
//		GL32.glDrawElementsInstancedBaseVertex(type, indicesSize, GL11.GL_UNSIGNED_SHORT, 0, numInstances, 0);
//		
//		for (int i = 0; i < 4; i++) {
//			GL20.glEnableVertexAttribArray(ml+i);
//			GL20.glVertexAttribPointer(ml+i, 4, GL11.GL_FLOAT, false, 0, 0);
//			GL33.glVertexAttribDivisor(ml+i, 0);
//		}
//		
//	}
//	
//	@Override
//	public void renderSingleInstance(int objectId, int type, int indicesSize) {
//		
//		GL32.glDrawElementsInstancedBaseVertex(type, indicesSize, GL11.GL_UNSIGNED_SHORT, 0, 1, 0);
//		
//	}
//	
//	@Override
//	public void deleteAll() {
//		super.deleteAll();
//		GL15.glDeleteBuffers(vboMatrixInstances);
//	}
//	
//}
