package modules.render.cpu.boundingsphere;

import java.util.ArrayList;

/**
 * Doesn't work for sphere. See http://www.inf.ethz.ch/personal/emo/DoctThesisFiles/fischer05.pdf chapter 5.1
 * 
 * Modified welzls algorithm for spheres not points.
 * 
 * @author DarkMatt
 *
 */

public class WelzlBoundingSphere extends AbstractBoundingSphereGenerator {
	
	/** Resulting Bounding-Sphere */
	private BoundingSphere boundingSphereResult;
	/** List of Bounding-Spheres to process */
	private ArrayList<BoundingSphere> boudingSpheresInput;
	
	/** Perform the algorithm */
	@Override
	public void calculateBoundingSphere() {
		boundingSphereResult = welzlRecursion(boudingSpheresInput, new ArrayList<BoundingSphere>());
	}
	
	private BoundingSphere welzlRecursion(ArrayList<BoundingSphere> pt, ArrayList<BoundingSphere> sos) {
		
		// if all points where removed
		if (pt.size() == 0) {
			int sosSize = sos.size();
			switch (sosSize) {
			case 0:
				return new BoundingSphere();
			case 1:
				return new BoundingSphere(sos.get(0));
			case 2: // 2 cases: sphere inside others
				return new BoundingSphere(sos.get(0), sos.get(1));
				
			default:
				break;
			}
		}
		
		// TODO: implement...
		
		return null;
	}
	
}
