package modules.render.objects;

import java.util.ArrayList;

import modules.render.Shader;
import modules.render.TextureCollection;
import modules.render.VBO;

public interface IRenderable {

	public static final float[] defaultVertexPositions = 
			new float[]{	0.0f, 0.0f, 0.0f, 
							1.0f, 0.0f, 0.0f,
							0.5f, 1.0f, 0.0f};
	public static final float[] defaultModelMatrix = 
			new float[]{	1.0f, 0.0f, 0.0f, 0.0f,
							0.0f, 1.0f, 0.0f, 0.0f,
							0.0f, 0.0f, 1.0f, 0.0f,
							0.0f, 0.0f, 0.0f, 1.0f};
	
	public void attachVertexData(ArrayList<VBOArrayObject> vertexData);
	public void uploadVertexData(VBO vbo);
	public boolean vertexDataIsUploaded();
	
	public void attachTexture(String textureName);
	public void uploadTexture(TextureCollection textures);
	
	public void translate(float x, float y, float z);
	public void rotateX(float angle);
	public void rotateY(float angle);
	public void rotateZ(float angle);
	public void uniformScale(float scale);
	
	public void draw(Shader shader, VBO vbo, TextureCollection textures);
	
}
