package modules.render.objects;

import java.nio.Buffer;

public class VBOArrayObject {
	
	public enum Location {
		DEFAULT_VERTEX_POSITION, DEFAULT_COLOR_POSITION, DEFAULT_TEXTCOORD_POSITION, DEFAULT_NORMAL_POSITION, DEFAULT_INDEX_POSITION
	}
	
	private Buffer data;
	private Location location; // location of the array object - can correspond to shader location
	private int type; // e.g. GL11.GL_FLOAT
	private int size; // per element
	
	public VBOArrayObject(Buffer data, Location location, int type, int size) {
		this.data = data;
		this.location = location;
		this.type = type;
		this.size = size;
	}
	
	public Buffer getData() {
		return data;
	}
	
	public int getLocation() {
		return location.ordinal();
	}
	
	public int getType() {
		return type;
	}
	
	public int getSize() {
		return size;
	}
	
	public VBOArrayObject copyWithoutBuffer() {
		return new VBOArrayObject(null, location, type, size);
	}
	
}
