package utility;

import java.nio.FloatBuffer;
import java.nio.IntBuffer;

import org.lwjgl.BufferUtils;
import org.lwjgl.util.vector.Matrix4f;

public class BufferConverter {
	
	public static FloatBuffer toBuffer(float[] data) {
		
		FloatBuffer out = BufferUtils.createFloatBuffer(data.length);
		out.put(data);
		out.flip();
		
		return out;
	}
	
	public static FloatBuffer toBuffer(Matrix4f data) {
		
		float[] dArray = {
			data.m00, data.m10, data.m20, data.m30,
			data.m01, data.m11, data.m21, data.m31,
			data.m02, data.m12, data.m22, data.m32,
			data.m03, data.m13, data.m23, data.m33
		};
		
		return toBuffer(dArray);
	}
	
	public static Matrix4f toMatrix(FloatBuffer data) {
		return (Matrix4f)new Matrix4f().load(data);
	}
	
	public static IntBuffer toBuffer(int[] data) {
		
		IntBuffer out = BufferUtils.createIntBuffer(data.length);
		out.put(data);
		out.flip();
		
		return out;
	}
	
}
