package utility;

/**
 * Encapsulation for FileReader and FileWriter.
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

public class FileIO {

	public static FileInputStream readFIS(String path) {
		
		FileInputStream fis;
		
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
		try {
			fis = new FileInputStream(f.getParent() + path);
		} catch (FileNotFoundException e) {
			throw new RuntimeException("Couldnt load file! Was looking for: " + f.getParent() + path +
					" \nReason: " + e);
		}
		
		return fis;
	}
	
	public static FileReader readFile(String path) {
		
		FileReader out;
		
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
		try {
			out = new FileReader(f.getParent() + path );
		} catch (FileNotFoundException e) {
			throw new RuntimeException("Couldnt load file! Was looking for: " + f.getParent() + path +
					" \nReason: " + e);
		}
		
		return out;
	}
	
	@Deprecated
	public static boolean fileExists(String path) {
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
        File f2 = new File(f.getParent() + path);
        
        return f2.exists();
	}
	
	@Deprecated
	public static FileReader readFileWOException(String path) {
		
		FileReader out = null;
		
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
		try {
			out = new FileReader(f.getParent() + path );
		} catch (FileNotFoundException e) {
			//System.out.println(path + " not found, returning null.");
		}
		
		return out;
	}
	
	@Deprecated
	public static FileWriter writeFile(String path) {
		
		FileWriter out = null;
		
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
		try {
			out = new FileWriter(f.getParent() + path );
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return out;
	}
	
	public static File getFile(String path) {
		URI uri = null;
		try {
			uri = new URI("file://"+FileIO.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
		
        File f = new File(uri);
        
        return new File(f.getParent() + path);
	}
	
}
