package utility;

import java.io.PrintStream;
import java.text.MessageFormat;

// http://jeeeyul.wordpress.com/2012/10/18/make-system-out-println-rocks/
public class SysoOverride extends PrintStream {

	private static final SysoOverride INSTANCE = new SysoOverride();
	 
	public static void activate() {
		System.setOut(INSTANCE);
	}
	 
	private SysoOverride() {
		super(System.out);
	}
	 
	@Override
	public void println(Object x) {
		showLocation();
		super.println(x);
	}
	
	@Override
	public void println(String x) {
		showLocation();
		super.println(x);
	}
	
	@Override
	public void println(boolean x) {
		showLocation();
		super.println(x);
	}
	 
	private void showLocation() {
		StackTraceElement element = Thread.currentThread().getStackTrace()[3];
		super.print(MessageFormat.format("({0}:{1, number,#}): ", element.getFileName(), element.getLineNumber()));
	}
	
}
